//  Created by Joe Becker on 3/7/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.

#import <Cocoa/Cocoa.h>
#import "GmtShipTrack.h"

@class GraphView;

@interface Controller : NSObject
{
    IBOutlet id graphView;
    IBOutlet id prefController;
	IBOutlet id navController;
	IBOutlet id dataController;
	IBOutlet id statController;
	
    IBOutlet id formatBox;
    IBOutlet id formatMatrix;
    NSSavePanel *sPanel;
	NSOpenPanel *oPanel;
	
	// The data we read from a GMT file
	NSString *aFile;
	GmtShipTrack *gmtShipTrack;
}

- (id)navController;
- (id)statController;
- (id)dataController;

- (IBAction)showPrefs:(id)sender;
- (GraphView *)graphView;
- (GmtShipTrack *)gmtShipTrack;
- (id)setGmtShipTrack:(GmtShipTrack *)track;

- (void)openDocument:(id)sender;

- (NSData *)PDFForView:(NSView *)aView;
- (IBAction)saveDocumentTo:(id)sender;
- (void)savePanelDidEnd:(NSSavePanel *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;
- (NSData *)TIFFForView:(NSView *)aView;

- (IBAction)setFormat:(id)sender;

// Chapter 20 - Pasteboard
- (void)copyToPasteboard:(NSPasteboard *)pboard; 
- (IBAction)pb_copy:(id)sender;
- (void)pasteboard:(NSPasteboard *)sender 
        provideDataForType:(NSString *)type;
    
    // Services
- (void)applicationDidFinishLaunching:(NSNotification *)aNot;
- (void)graphFormula:(NSPasteboard *)pboard
            userData:(NSString *)userData
               error:(NSString **)error;


// Chapter 21 - Defaults
- (void) awakeFromNib;

@end
