//  Created by Joe Becker on 3/7/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.

#import <Cocoa/Cocoa.h>
#import "define.h"
#import "GmtShipTrackRecord.h"


@interface GmtShipTrack : NSObject {
	NSMutableArray *gmtShipTrackRecordList;
	
	GmtShipTrackRecord *max;
	GmtShipTrackRecord *min;
	GmtShipTrackRecord *mean;
	GmtShipTrackRecord *stdDev;
	GmtShipTrackRecord *slope;
	GmtShipTrackRecord *offset;

	GmtShipTrackRecord *numGood;
	GmtShipTrackRecord *sumOfX;
	GmtShipTrackRecord *sumOfXSqr;
	GmtShipTrackRecord *sumOfY;
	GmtShipTrackRecord *sumOfYSqr;
	GmtShipTrackRecord *sumOfXY;
	GmtShipTrackRecord *sumOfDeltaY;
	GmtShipTrackRecord *sumOfXDeltaY;
	GmtShipTrackRecord *sumOfDeltaYSqr;
	
	NSString *firstLineOfFile;
	NSString *secondLineOfFile;
	
	double		carterCount;
}

- (id)readFromPath:(NSString *)filePath;
- (id)writeToPath:(NSString *)filePath;

- (id)gmtShipTrackRecordList;

- (BOOL) isNaN:(double)x;
- (id)setDoubleWithNaN:(id)cell:(double)data;

- (GmtShipTrackRecord *)maxRecordOf:(GmtShipTrackRecord *)a:(GmtShipTrackRecord *)b;
- (GmtShipTrackRecord *)minRecordOf:(GmtShipTrackRecord *)a:(GmtShipTrackRecord *)b;

- (void)calculateSumsForStats;

- (GmtShipTrackRecord *)max;
- (GmtShipTrackRecord *)min;
- (GmtShipTrackRecord *)mean;
- (GmtShipTrackRecord *)stdDev;
- (GmtShipTrackRecord *)slope;
- (GmtShipTrackRecord *)offset;
- (GmtShipTrackRecord *)numGood;

- (GmtShipTrackRecord *)objectAt:(int)dataField:(float)x:(float)y;

- (double)carterCount;
- (double)setCarterCount:(double)cnt;

- (void)addCarterCorrection;
- (void)subCarterCorrection;

- (NSRect)extent:(int)field;

@end
