//  Created by Joe Becker on 3/7/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.

#import <Cocoa/Cocoa.h>
#import "define.h"
#import "GmtShipTrack.h"

@interface GraphView : NSView
{
    IBOutlet id formulaField;
    IBOutlet id graphButton;
    IBOutlet id xmaxCell;
    IBOutlet id xminCell;
    IBOutlet id xstepCell;
    IBOutlet id ymaxCell;
    IBOutlet id yminCell;
	IBOutlet id controller;
	IBOutlet id carterCountCell;

	IBOutlet id dataTypeField;
	
	IBOutlet id meanCell;
	IBOutlet id stdDevCell;
	IBOutlet id slopeCell;
	IBOutlet id offsetCell;
	IBOutlet id countCell;

    // These hold the contents of the NSForm
    double      xmin;
    double      xmax;
    double      xstep;
    double      ymin;
    double      ymax;

    // Display list and glue
    NSMutableArray *displayList;
    BOOL		first;        // Getting the first point?
    NSPoint		lastPt;       // Last point received

    // Services
    BOOL runningAsService;
}

- (void)gotData:(id)sender;
- (IBAction)graph:(id)sender;
- (void)getForm;
- (void)getFormAndScaleView;
- (void)addGraphElement:(id)element;
- (void)clear;
- (void)addAxesFrom:(NSPoint)pt1 to:(NSPoint)pt2;

	// Services
- (void)setFormula:(NSString *)aString;
- (void)setRunningAsService:(BOOL)flag;

// Drag-and-Drop
-(BOOL)acceptsFirstMouse:(NSEvent *)theEvent;
-(NSDragOperation)draggingSourceOperationMaskForLocal:(BOOL)flag;


// Chapter 21 - Defaults
+ (void) initialize;
- (void) awakeFromNib;

- (id) zoomToDataExtent:(GmtShipTrack *)gmtShipTrack :(int)field;
- (id) zoomToDataExtent:(GmtShipTrack *)gmtShipTrack;
- (id) zoomToVerticalExtent:(GmtShipTrack *)gmtShipTrack :(int)field;
- (id) zoomToVerticalExtent:(GmtShipTrack *)gmtShipTrack;
- (id) carterCountCell;

@end

@protocol GraphViewElement
- (int)tag;
- (void)setTag:(int)aTag;
- (void)stroke;
- (NSRect)bounds;
- (NSPoint)center;
- (void)setColor:(NSColor *)aColor;
- (NSColor *)color;

@end